# Waterfall versions (/docs/api/waterfalls/waterfall_versions)

Every published version (immutable), newest first.

`GET /v1/waterfalls/{id}/versions`

```json
{
  "operationId": "waterfall_versions",
  "summary": "Waterfall versions",
  "description": "Every published version (immutable), newest first.",
  "tags": [
    "waterfalls"
  ],
  "security": [
    {
      "bearer": []
    }
  ],
  "parameters": [
    {
      "schema": {
        "type": "string",
        "pattern": "^wf_[a-z0-9]{8,40}$"
      },
      "required": true,
      "name": "id",
      "in": "path"
    }
  ],
  "responses": {
    "200": {
      "description": "OK",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "properties": {
              "items": {
                "type": "array",
                "items": {
                  "type": "object",
                  "properties": {
                    "version": {
                      "type": "string",
                      "pattern": "^\\d{1,4}\\.\\d{1,4}\\.\\d{1,4}$"
                    },
                    "definition": {
                      "oneOf": [
                        {
                          "type": "object",
                          "properties": {
                            "kind": {
                              "type": "string",
                              "enum": [
                                "waterfall"
                              ]
                            },
                            "id": {
                              "type": "string",
                              "minLength": 1,
                              "maxLength": 40,
                              "pattern": "^[a-z0-9][a-z0-9_-]*$",
                              "default": "main"
                            },
                            "capability": {
                              "type": "string",
                              "pattern": "^[a-z]+(\\.[a-z0-9_]+)+$"
                            },
                            "steps": {
                              "type": "array",
                              "items": {
                                "oneOf": [
                                  {
                                    "type": "object",
                                    "properties": {
                                      "type": {
                                        "type": "string",
                                        "enum": [
                                          "endpoint"
                                        ]
                                      },
                                      "endpoint_id": {
                                        "type": "string",
                                        "minLength": 3,
                                        "maxLength": 200
                                      },
                                      "id": {
                                        "type": "string",
                                        "minLength": 1,
                                        "maxLength": 40,
                                        "pattern": "^[a-z0-9][a-z0-9_-]*$",
                                        "description": "Stable id; defaults to the endpoint id"
                                      },
                                      "timeout_ms": {
                                        "type": "integer",
                                        "minimum": 100,
                                        "maximum": 120000
                                      },
                                      "retries": {
                                        "type": "integer",
                                        "minimum": 0,
                                        "maximum": 5,
                                        "default": 0,
                                        "description": "Retries on 5xx and timeouts"
                                      },
                                      "retry_backoff_ms": {
                                        "type": "integer",
                                        "minimum": 0,
                                        "maximum": 30000,
                                        "default": 250
                                      },
                                      "max_cost_micro": {
                                        "type": "integer",
                                        "minimum": 0,
                                        "description": "Skip this step if its quote is above this"
                                      },
                                      "required_fields": {
                                        "type": "array",
                                        "items": {
                                          "type": "string",
                                          "maxLength": 80,
                                          "pattern": "^[a-z][a-z0-9_]*(\\.[a-z][a-z0-9_]*)*$"
                                        },
                                        "maxItems": 20,
                                        "default": []
                                      },
                                      "min_confidence": {
                                        "type": "number",
                                        "minimum": 0,
                                        "maximum": 100
                                      },
                                      "confidence_field": {
                                        "type": "string",
                                        "maxLength": 80,
                                        "pattern": "^[a-z][a-z0-9_]*(\\.[a-z][a-z0-9_]*)*$",
                                        "default": "confidence"
                                      },
                                      "prefer_verified": {
                                        "type": "boolean",
                                        "default": false
                                      },
                                      "continue_on_hit": {
                                        "type": "boolean",
                                        "default": false
                                      },
                                      "credential": {
                                        "type": "string",
                                        "enum": [
                                          "auto",
                                          "managed",
                                          "byok"
                                        ],
                                        "default": "auto"
                                      },
                                      "on_client_error": {
                                        "type": "string",
                                        "enum": [
                                          "continue",
                                          "fail"
                                        ],
                                        "default": "continue"
                                      },
                                      "when": {
                                        "anyOf": [
                                          {
                                            "type": "object",
                                            "properties": {
                                              "field": {
                                                "type": "string",
                                                "maxLength": 120,
                                                "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                              },
                                              "op": {
                                                "type": "string",
                                                "enum": [
                                                  "eq",
                                                  "neq",
                                                  "gt",
                                                  "gte",
                                                  "lt",
                                                  "lte",
                                                  "exists",
                                                  "not_exists",
                                                  "non_empty",
                                                  "contains",
                                                  "starts_with",
                                                  "ends_with",
                                                  "in",
                                                  "not_in"
                                                ]
                                              },
                                              "value": {
                                                "anyOf": [
                                                  {
                                                    "type": "string",
                                                    "maxLength": 500
                                                  },
                                                  {
                                                    "type": "number"
                                                  },
                                                  {
                                                    "type": "boolean"
                                                  },
                                                  {
                                                    "type": "null"
                                                  },
                                                  {
                                                    "type": "array",
                                                    "items": {
                                                      "anyOf": [
                                                        {
                                                          "type": "string",
                                                          "maxLength": 500
                                                        },
                                                        {
                                                          "type": "number"
                                                        },
                                                        {
                                                          "type": "boolean"
                                                        },
                                                        {
                                                          "type": "null"
                                                        }
                                                      ]
                                                    },
                                                    "maxItems": 50
                                                  }
                                                ]
                                              }
                                            },
                                            "required": [
                                              "field",
                                              "op"
                                            ]
                                          },
                                          {
                                            "type": "object",
                                            "properties": {
                                              "all": {
                                                "type": "array",
                                                "items": {
                                                  "type": "object",
                                                  "properties": {
                                                    "field": {
                                                      "type": "string",
                                                      "maxLength": 120,
                                                      "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                    },
                                                    "op": {
                                                      "type": "string",
                                                      "enum": [
                                                        "eq",
                                                        "neq",
                                                        "gt",
                                                        "gte",
                                                        "lt",
                                                        "lte",
                                                        "exists",
                                                        "not_exists",
                                                        "non_empty",
                                                        "contains",
                                                        "starts_with",
                                                        "ends_with",
                                                        "in",
                                                        "not_in"
                                                      ]
                                                    },
                                                    "value": {
                                                      "anyOf": [
                                                        {
                                                          "type": "string",
                                                          "maxLength": 500
                                                        },
                                                        {
                                                          "type": "number"
                                                        },
                                                        {
                                                          "type": "boolean"
                                                        },
                                                        {
                                                          "type": "null"
                                                        },
                                                        {
                                                          "type": "array",
                                                          "items": {
                                                            "anyOf": [
                                                              {
                                                                "type": "string",
                                                                "maxLength": 500
                                                              },
                                                              {
                                                                "type": "number"
                                                              },
                                                              {
                                                                "type": "boolean"
                                                              },
                                                              {
                                                                "type": "null"
                                                              }
                                                            ]
                                                          },
                                                          "maxItems": 50
                                                        }
                                                      ]
                                                    }
                                                  },
                                                  "required": [
                                                    "field",
                                                    "op"
                                                  ]
                                                },
                                                "minItems": 1,
                                                "maxItems": 20
                                              }
                                            },
                                            "required": [
                                              "all"
                                            ]
                                          },
                                          {
                                            "type": "object",
                                            "properties": {
                                              "any": {
                                                "type": "array",
                                                "items": {
                                                  "type": "object",
                                                  "properties": {
                                                    "field": {
                                                      "type": "string",
                                                      "maxLength": 120,
                                                      "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                    },
                                                    "op": {
                                                      "type": "string",
                                                      "enum": [
                                                        "eq",
                                                        "neq",
                                                        "gt",
                                                        "gte",
                                                        "lt",
                                                        "lte",
                                                        "exists",
                                                        "not_exists",
                                                        "non_empty",
                                                        "contains",
                                                        "starts_with",
                                                        "ends_with",
                                                        "in",
                                                        "not_in"
                                                      ]
                                                    },
                                                    "value": {
                                                      "anyOf": [
                                                        {
                                                          "type": "string",
                                                          "maxLength": 500
                                                        },
                                                        {
                                                          "type": "number"
                                                        },
                                                        {
                                                          "type": "boolean"
                                                        },
                                                        {
                                                          "type": "null"
                                                        },
                                                        {
                                                          "type": "array",
                                                          "items": {
                                                            "anyOf": [
                                                              {
                                                                "type": "string",
                                                                "maxLength": 500
                                                              },
                                                              {
                                                                "type": "number"
                                                              },
                                                              {
                                                                "type": "boolean"
                                                              },
                                                              {
                                                                "type": "null"
                                                              }
                                                            ]
                                                          },
                                                          "maxItems": 50
                                                        }
                                                      ]
                                                    }
                                                  },
                                                  "required": [
                                                    "field",
                                                    "op"
                                                  ]
                                                },
                                                "minItems": 1,
                                                "maxItems": 20
                                              }
                                            },
                                            "required": [
                                              "any"
                                            ]
                                          },
                                          {
                                            "type": "object",
                                            "properties": {
                                              "not": {
                                                "type": "object",
                                                "properties": {
                                                  "field": {
                                                    "type": "string",
                                                    "maxLength": 120,
                                                    "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                  },
                                                  "op": {
                                                    "type": "string",
                                                    "enum": [
                                                      "eq",
                                                      "neq",
                                                      "gt",
                                                      "gte",
                                                      "lt",
                                                      "lte",
                                                      "exists",
                                                      "not_exists",
                                                      "non_empty",
                                                      "contains",
                                                      "starts_with",
                                                      "ends_with",
                                                      "in",
                                                      "not_in"
                                                    ]
                                                  },
                                                  "value": {
                                                    "anyOf": [
                                                      {
                                                        "type": "string",
                                                        "maxLength": 500
                                                      },
                                                      {
                                                        "type": "number"
                                                      },
                                                      {
                                                        "type": "boolean"
                                                      },
                                                      {
                                                        "type": "null"
                                                      },
                                                      {
                                                        "type": "array",
                                                        "items": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            }
                                                          ]
                                                        },
                                                        "maxItems": 50
                                                      }
                                                    ]
                                                  }
                                                },
                                                "required": [
                                                  "field",
                                                  "op"
                                                ]
                                              }
                                            },
                                            "required": [
                                              "not"
                                            ]
                                          },
                                          {
                                            "type": "object",
                                            "properties": {
                                              "all": {
                                                "type": "array",
                                                "items": {
                                                  "anyOf": [
                                                    {
                                                      "type": "object",
                                                      "properties": {
                                                        "field": {
                                                          "type": "string",
                                                          "maxLength": 120,
                                                          "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                        },
                                                        "op": {
                                                          "type": "string",
                                                          "enum": [
                                                            "eq",
                                                            "neq",
                                                            "gt",
                                                            "gte",
                                                            "lt",
                                                            "lte",
                                                            "exists",
                                                            "not_exists",
                                                            "non_empty",
                                                            "contains",
                                                            "starts_with",
                                                            "ends_with",
                                                            "in",
                                                            "not_in"
                                                          ]
                                                        },
                                                        "value": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            },
                                                            {
                                                              "type": "array",
                                                              "items": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  }
                                                                ]
                                                              },
                                                              "maxItems": 50
                                                            }
                                                          ]
                                                        }
                                                      },
                                                      "required": [
                                                        "field",
                                                        "op"
                                                      ]
                                                    },
                                                    {
                                                      "type": "object",
                                                      "properties": {
                                                        "all": {
                                                          "type": "array",
                                                          "items": {
                                                            "type": "object",
                                                            "properties": {
                                                              "field": {
                                                                "type": "string",
                                                                "maxLength": 120,
                                                                "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                              },
                                                              "op": {
                                                                "type": "string",
                                                                "enum": [
                                                                  "eq",
                                                                  "neq",
                                                                  "gt",
                                                                  "gte",
                                                                  "lt",
                                                                  "lte",
                                                                  "exists",
                                                                  "not_exists",
                                                                  "non_empty",
                                                                  "contains",
                                                                  "starts_with",
                                                                  "ends_with",
                                                                  "in",
                                                                  "not_in"
                                                                ]
                                                              },
                                                              "value": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  },
                                                                  {
                                                                    "type": "array",
                                                                    "items": {
                                                                      "anyOf": [
                                                                        {
                                                                          "type": "string",
                                                                          "maxLength": 500
                                                                        },
                                                                        {
                                                                          "type": "number"
                                                                        },
                                                                        {
                                                                          "type": "boolean"
                                                                        },
                                                                        {
                                                                          "type": "null"
                                                                        }
                                                                      ]
                                                                    },
                                                                    "maxItems": 50
                                                                  }
                                                                ]
                                                              }
                                                            },
                                                            "required": [
                                                              "field",
                                                              "op"
                                                            ]
                                                          },
                                                          "minItems": 1,
                                                          "maxItems": 20
                                                        }
                                                      },
                                                      "required": [
                                                        "all"
                                                      ]
                                                    },
                                                    {
                                                      "type": "object",
                                                      "properties": {
                                                        "any": {
                                                          "type": "array",
                                                          "items": {
                                                            "type": "object",
                                                            "properties": {
                                                              "field": {
                                                                "type": "string",
                                                                "maxLength": 120,
                                                                "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                              },
                                                              "op": {
                                                                "type": "string",
                                                                "enum": [
                                                                  "eq",
                                                                  "neq",
                                                                  "gt",
                                                                  "gte",
                                                                  "lt",
                                                                  "lte",
                                                                  "exists",
                                                                  "not_exists",
                                                                  "non_empty",
                                                                  "contains",
                                                                  "starts_with",
                                                                  "ends_with",
                                                                  "in",
                                                                  "not_in"
                                                                ]
                                                              },
                                                              "value": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  },
                                                                  {
                                                                    "type": "array",
                                                                    "items": {
                                                                      "anyOf": [
                                                                        {
                                                                          "type": "string",
                                                                          "maxLength": 500
                                                                        },
                                                                        {
                                                                          "type": "number"
                                                                        },
                                                                        {
                                                                          "type": "boolean"
                                                                        },
                                                                        {
                                                                          "type": "null"
                                                                        }
                                                                      ]
                                                                    },
                                                                    "maxItems": 50
                                                                  }
                                                                ]
                                                              }
                                                            },
                                                            "required": [
                                                              "field",
                                                              "op"
                                                            ]
                                                          },
                                                          "minItems": 1,
                                                          "maxItems": 20
                                                        }
                                                      },
                                                      "required": [
                                                        "any"
                                                      ]
                                                    },
                                                    {
                                                      "type": "object",
                                                      "properties": {
                                                        "not": {
                                                          "type": "object",
                                                          "properties": {
                                                            "field": {
                                                              "type": "string",
                                                              "maxLength": 120,
                                                              "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                            },
                                                            "op": {
                                                              "type": "string",
                                                              "enum": [
                                                                "eq",
                                                                "neq",
                                                                "gt",
                                                                "gte",
                                                                "lt",
                                                                "lte",
                                                                "exists",
                                                                "not_exists",
                                                                "non_empty",
                                                                "contains",
                                                                "starts_with",
                                                                "ends_with",
                                                                "in",
                                                                "not_in"
                                                              ]
                                                            },
                                                            "value": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                },
                                                                {
                                                                  "type": "array",
                                                                  "items": {
                                                                    "anyOf": [
                                                                      {
                                                                        "type": "string",
                                                                        "maxLength": 500
                                                                      },
                                                                      {
                                                                        "type": "number"
                                                                      },
                                                                      {
                                                                        "type": "boolean"
                                                                      },
                                                                      {
                                                                        "type": "null"
                                                                      }
                                                                    ]
                                                                  },
                                                                  "maxItems": 50
                                                                }
                                                              ]
                                                            }
                                                          },
                                                          "required": [
                                                            "field",
                                                            "op"
                                                          ]
                                                        }
                                                      },
                                                      "required": [
                                                        "not"
                                                      ]
                                                    }
                                                  ]
                                                },
                                                "minItems": 1,
                                                "maxItems": 20
                                              }
                                            },
                                            "required": [
                                              "all"
                                            ]
                                          },
                                          {
                                            "type": "object",
                                            "properties": {
                                              "any": {
                                                "type": "array",
                                                "items": {
                                                  "anyOf": [
                                                    {
                                                      "type": "object",
                                                      "properties": {
                                                        "field": {
                                                          "type": "string",
                                                          "maxLength": 120,
                                                          "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                        },
                                                        "op": {
                                                          "type": "string",
                                                          "enum": [
                                                            "eq",
                                                            "neq",
                                                            "gt",
                                                            "gte",
                                                            "lt",
                                                            "lte",
                                                            "exists",
                                                            "not_exists",
                                                            "non_empty",
                                                            "contains",
                                                            "starts_with",
                                                            "ends_with",
                                                            "in",
                                                            "not_in"
                                                          ]
                                                        },
                                                        "value": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            },
                                                            {
                                                              "type": "array",
                                                              "items": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  }
                                                                ]
                                                              },
                                                              "maxItems": 50
                                                            }
                                                          ]
                                                        }
                                                      },
                                                      "required": [
                                                        "field",
                                                        "op"
                                                      ]
                                                    },
                                                    {
                                                      "type": "object",
                                                      "properties": {
                                                        "all": {
                                                          "type": "array",
                                                          "items": {
                                                            "type": "object",
                                                            "properties": {
                                                              "field": {
                                                                "type": "string",
                                                                "maxLength": 120,
                                                                "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                              },
                                                              "op": {
                                                                "type": "string",
                                                                "enum": [
                                                                  "eq",
                                                                  "neq",
                                                                  "gt",
                                                                  "gte",
                                                                  "lt",
                                                                  "lte",
                                                                  "exists",
                                                                  "not_exists",
                                                                  "non_empty",
                                                                  "contains",
                                                                  "starts_with",
                                                                  "ends_with",
                                                                  "in",
                                                                  "not_in"
                                                                ]
                                                              },
                                                              "value": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  },
                                                                  {
                                                                    "type": "array",
                                                                    "items": {
                                                                      "anyOf": [
                                                                        {
                                                                          "type": "string",
                                                                          "maxLength": 500
                                                                        },
                                                                        {
                                                                          "type": "number"
                                                                        },
                                                                        {
                                                                          "type": "boolean"
                                                                        },
                                                                        {
                                                                          "type": "null"
                                                                        }
                                                                      ]
                                                                    },
                                                                    "maxItems": 50
                                                                  }
                                                                ]
                                                              }
                                                            },
                                                            "required": [
                                                              "field",
                                                              "op"
                                                            ]
                                                          },
                                                          "minItems": 1,
                                                          "maxItems": 20
                                                        }
                                                      },
                                                      "required": [
                                                        "all"
                                                      ]
                                                    },
                                                    {
                                                      "type": "object",
                                                      "properties": {
                                                        "any": {
                                                          "type": "array",
                                                          "items": {
                                                            "type": "object",
                                                            "properties": {
                                                              "field": {
                                                                "type": "string",
                                                                "maxLength": 120,
                                                                "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                              },
                                                              "op": {
                                                                "type": "string",
                                                                "enum": [
                                                                  "eq",
                                                                  "neq",
                                                                  "gt",
                                                                  "gte",
                                                                  "lt",
                                                                  "lte",
                                                                  "exists",
                                                                  "not_exists",
                                                                  "non_empty",
                                                                  "contains",
                                                                  "starts_with",
                                                                  "ends_with",
                                                                  "in",
                                                                  "not_in"
                                                                ]
                                                              },
                                                              "value": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  },
                                                                  {
                                                                    "type": "array",
                                                                    "items": {
                                                                      "anyOf": [
                                                                        {
                                                                          "type": "string",
                                                                          "maxLength": 500
                                                                        },
                                                                        {
                                                                          "type": "number"
                                                                        },
                                                                        {
                                                                          "type": "boolean"
                                                                        },
                                                                        {
                                                                          "type": "null"
                                                                        }
                                                                      ]
                                                                    },
                                                                    "maxItems": 50
                                                                  }
                                                                ]
                                                              }
                                                            },
                                                            "required": [
                                                              "field",
                                                              "op"
                                                            ]
                                                          },
                                                          "minItems": 1,
                                                          "maxItems": 20
                                                        }
                                                      },
                                                      "required": [
                                                        "any"
                                                      ]
                                                    },
                                                    {
                                                      "type": "object",
                                                      "properties": {
                                                        "not": {
                                                          "type": "object",
                                                          "properties": {
                                                            "field": {
                                                              "type": "string",
                                                              "maxLength": 120,
                                                              "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                            },
                                                            "op": {
                                                              "type": "string",
                                                              "enum": [
                                                                "eq",
                                                                "neq",
                                                                "gt",
                                                                "gte",
                                                                "lt",
                                                                "lte",
                                                                "exists",
                                                                "not_exists",
                                                                "non_empty",
                                                                "contains",
                                                                "starts_with",
                                                                "ends_with",
                                                                "in",
                                                                "not_in"
                                                              ]
                                                            },
                                                            "value": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                },
                                                                {
                                                                  "type": "array",
                                                                  "items": {
                                                                    "anyOf": [
                                                                      {
                                                                        "type": "string",
                                                                        "maxLength": 500
                                                                      },
                                                                      {
                                                                        "type": "number"
                                                                      },
                                                                      {
                                                                        "type": "boolean"
                                                                      },
                                                                      {
                                                                        "type": "null"
                                                                      }
                                                                    ]
                                                                  },
                                                                  "maxItems": 50
                                                                }
                                                              ]
                                                            }
                                                          },
                                                          "required": [
                                                            "field",
                                                            "op"
                                                          ]
                                                        }
                                                      },
                                                      "required": [
                                                        "not"
                                                      ]
                                                    }
                                                  ]
                                                },
                                                "minItems": 1,
                                                "maxItems": 20
                                              }
                                            },
                                            "required": [
                                              "any"
                                            ]
                                          },
                                          {
                                            "type": "object",
                                            "properties": {
                                              "not": {
                                                "anyOf": [
                                                  {
                                                    "type": "object",
                                                    "properties": {
                                                      "field": {
                                                        "type": "string",
                                                        "maxLength": 120,
                                                        "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                      },
                                                      "op": {
                                                        "type": "string",
                                                        "enum": [
                                                          "eq",
                                                          "neq",
                                                          "gt",
                                                          "gte",
                                                          "lt",
                                                          "lte",
                                                          "exists",
                                                          "not_exists",
                                                          "non_empty",
                                                          "contains",
                                                          "starts_with",
                                                          "ends_with",
                                                          "in",
                                                          "not_in"
                                                        ]
                                                      },
                                                      "value": {
                                                        "anyOf": [
                                                          {
                                                            "type": "string",
                                                            "maxLength": 500
                                                          },
                                                          {
                                                            "type": "number"
                                                          },
                                                          {
                                                            "type": "boolean"
                                                          },
                                                          {
                                                            "type": "null"
                                                          },
                                                          {
                                                            "type": "array",
                                                            "items": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                }
                                                              ]
                                                            },
                                                            "maxItems": 50
                                                          }
                                                        ]
                                                      }
                                                    },
                                                    "required": [
                                                      "field",
                                                      "op"
                                                    ]
                                                  },
                                                  {
                                                    "type": "object",
                                                    "properties": {
                                                      "all": {
                                                        "type": "array",
                                                        "items": {
                                                          "type": "object",
                                                          "properties": {
                                                            "field": {
                                                              "type": "string",
                                                              "maxLength": 120,
                                                              "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                            },
                                                            "op": {
                                                              "type": "string",
                                                              "enum": [
                                                                "eq",
                                                                "neq",
                                                                "gt",
                                                                "gte",
                                                                "lt",
                                                                "lte",
                                                                "exists",
                                                                "not_exists",
                                                                "non_empty",
                                                                "contains",
                                                                "starts_with",
                                                                "ends_with",
                                                                "in",
                                                                "not_in"
                                                              ]
                                                            },
                                                            "value": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                },
                                                                {
                                                                  "type": "array",
                                                                  "items": {
                                                                    "anyOf": [
                                                                      {
                                                                        "type": "string",
                                                                        "maxLength": 500
                                                                      },
                                                                      {
                                                                        "type": "number"
                                                                      },
                                                                      {
                                                                        "type": "boolean"
                                                                      },
                                                                      {
                                                                        "type": "null"
                                                                      }
                                                                    ]
                                                                  },
                                                                  "maxItems": 50
                                                                }
                                                              ]
                                                            }
                                                          },
                                                          "required": [
                                                            "field",
                                                            "op"
                                                          ]
                                                        },
                                                        "minItems": 1,
                                                        "maxItems": 20
                                                      }
                                                    },
                                                    "required": [
                                                      "all"
                                                    ]
                                                  },
                                                  {
                                                    "type": "object",
                                                    "properties": {
                                                      "any": {
                                                        "type": "array",
                                                        "items": {
                                                          "type": "object",
                                                          "properties": {
                                                            "field": {
                                                              "type": "string",
                                                              "maxLength": 120,
                                                              "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                            },
                                                            "op": {
                                                              "type": "string",
                                                              "enum": [
                                                                "eq",
                                                                "neq",
                                                                "gt",
                                                                "gte",
                                                                "lt",
                                                                "lte",
                                                                "exists",
                                                                "not_exists",
                                                                "non_empty",
                                                                "contains",
                                                                "starts_with",
                                                                "ends_with",
                                                                "in",
                                                                "not_in"
                                                              ]
                                                            },
                                                            "value": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                },
                                                                {
                                                                  "type": "array",
                                                                  "items": {
                                                                    "anyOf": [
                                                                      {
                                                                        "type": "string",
                                                                        "maxLength": 500
                                                                      },
                                                                      {
                                                                        "type": "number"
                                                                      },
                                                                      {
                                                                        "type": "boolean"
                                                                      },
                                                                      {
                                                                        "type": "null"
                                                                      }
                                                                    ]
                                                                  },
                                                                  "maxItems": 50
                                                                }
                                                              ]
                                                            }
                                                          },
                                                          "required": [
                                                            "field",
                                                            "op"
                                                          ]
                                                        },
                                                        "minItems": 1,
                                                        "maxItems": 20
                                                      }
                                                    },
                                                    "required": [
                                                      "any"
                                                    ]
                                                  },
                                                  {
                                                    "type": "object",
                                                    "properties": {
                                                      "not": {
                                                        "type": "object",
                                                        "properties": {
                                                          "field": {
                                                            "type": "string",
                                                            "maxLength": 120,
                                                            "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                          },
                                                          "op": {
                                                            "type": "string",
                                                            "enum": [
                                                              "eq",
                                                              "neq",
                                                              "gt",
                                                              "gte",
                                                              "lt",
                                                              "lte",
                                                              "exists",
                                                              "not_exists",
                                                              "non_empty",
                                                              "contains",
                                                              "starts_with",
                                                              "ends_with",
                                                              "in",
                                                              "not_in"
                                                            ]
                                                          },
                                                          "value": {
                                                            "anyOf": [
                                                              {
                                                                "type": "string",
                                                                "maxLength": 500
                                                              },
                                                              {
                                                                "type": "number"
                                                              },
                                                              {
                                                                "type": "boolean"
                                                              },
                                                              {
                                                                "type": "null"
                                                              },
                                                              {
                                                                "type": "array",
                                                                "items": {
                                                                  "anyOf": [
                                                                    {
                                                                      "type": "string",
                                                                      "maxLength": 500
                                                                    },
                                                                    {
                                                                      "type": "number"
                                                                    },
                                                                    {
                                                                      "type": "boolean"
                                                                    },
                                                                    {
                                                                      "type": "null"
                                                                    }
                                                                  ]
                                                                },
                                                                "maxItems": 50
                                                              }
                                                            ]
                                                          }
                                                        },
                                                        "required": [
                                                          "field",
                                                          "op"
                                                        ]
                                                      }
                                                    },
                                                    "required": [
                                                      "not"
                                                    ]
                                                  }
                                                ]
                                              }
                                            },
                                            "required": [
                                              "not"
                                            ]
                                          }
                                        ]
                                      }
                                    },
                                    "required": [
                                      "type",
                                      "endpoint_id"
                                    ]
                                  },
                                  {
                                    "type": "object",
                                    "properties": {
                                      "type": {
                                        "type": "string",
                                        "enum": [
                                          "routed"
                                        ]
                                      },
                                      "provider": {
                                        "type": "object",
                                        "properties": {
                                          "order": {
                                            "type": "array",
                                            "items": {
                                              "type": "string"
                                            },
                                            "maxItems": 20
                                          },
                                          "only": {
                                            "type": "array",
                                            "items": {
                                              "type": "string"
                                            },
                                            "maxItems": 20
                                          },
                                          "ignore": {
                                            "type": "array",
                                            "items": {
                                              "type": "string"
                                            },
                                            "maxItems": 20
[...]
